//Listing 2:	The class hierarchy of machine code operations.


class Operation
{
public:
	virtual void execute() = 0;
}

class Literal_number : public Operation
{
private:
	int value;
public:
	virtual void execute();
}

class Variable_value : public Operation
{
private:
	String name;
public:
	virtual void execute();
}

class Add_operation : public Operation
{
public:
	virtual void execute();
}

class Function_call : public Operation
{
private:
	String name;
	int num_passed_arguments;
public:
	virtual void execute();
}

class Assignment : public Operation
{
private:
	String target_variable_name;
public:
	virtual void execute();
}

class Display_value : public Operation
{
public:
	virtual void execute();
}

